Subject: Outdated note about unique indexes

From: Josh Kupershmidt <[email-masked]>
Date: Wed, 8 Jul 2015 17:56:09 -0400

Hi,

I noticed that the note on a page about unique indexes

http://www.postgresql.org/docs/current/static/indexes-unique.html

says "The preferred way to add a unique constraint to a table is ALTER
TABLE ... ADD CONSTRAINT. The use of indexes to enforce unique constraints
could be considered an implementation detail that should not be accessed
directly... ".

That note has been there forever, in particular since before we supported
CONCURRENTLY, which is pretty darn important in many uses nowadays. Since
it seems like some users have taken this suggestion seriously, e.g. on
stackoverflow[1], how about we remove this outdated suggestion? There is
already a previous mention a few sections earlier[2] suggesting the use of
CONCURRENTLY, so I don't think we really need to reiterate that suggestion
here.

Josh

[1]
http://stackoverflow.com/questions/23542794/postgres-unique-constraint-vs-index
[2] http://www.postgresql.org/docs/current/interactive/indexes-intro.html
diff --git a/doc/src/sgml/indices.sgml b/doc/src/sgml/indices.sgml
index 309fd12..2d131c9 100644
--- a/doc/src/sgml/indices.sgml
+++ b/doc/src/sgml/indices.sgml
@@ -655,11 +655,7 @@ CREATE UNIQUE INDEX <replaceable>name</replaceable> ON <replaceable>table</repla
 
   <note>
    <para>
-    The preferred way to add a unique constraint to a table is
-    <literal>ALTER TABLE ... ADD CONSTRAINT</literal>.  The use of
-    indexes to enforce unique constraints could be considered an
-    implementation detail that should not be accessed directly.
-    One should, however, be aware that there's no need to manually
+    There's no need to manually
     create indexes on unique columns; doing so would just duplicate
     the automatically-created index.
    </para>

-- 
Sent via pgsql-docs mailing list ([email-masked])
To make changes to your subscription:
http://www.postgresql.org/mailpref/pgsql-docs

---

From: Josh Berkus <[email-masked]>
Date: Wed, 08 Jul 2015 15:10:46 -0700

> That note has been there forever, in particular since before we
> supported CONCURRENTLY, which is pretty darn important in many uses
> nowadays. Since it seems like some users have taken this suggestion
> seriously, e.g. on stackoverflow[1], how about we remove this outdated
> suggestion? There is already a previous mention a few sections
> earlier[2] suggesting the use of CONCURRENTLY, so I don't think we
> really need to reiterate that suggestion here.

+1

-- 
Josh Berkus
PostgreSQL Experts Inc.
http://pgexperts.com

---

From: Bruce Momjian <[email-masked]>
Date: Mon, 31 Aug 2015 17:05:41 -0400

> > really need to reiterate that suggestion here.

Patch applied through 9.5.

-- 
  Bruce Momjian  <[email-masked]>        http://momjian.us
  EnterpriseDB                             http://enterprisedb.com

  + Everyone has their own god. +